package fr.vincent.ramiere.mangerautourdesimplonback.models;

import com.fasterxml.jackson.annotation.JsonIgnore;
import jakarta.persistence.*;
import lombok.*;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;

@Entity
@Table(name = "restaurant")
@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class Restaurant implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id_restau")
    private int id;

    @Column(nullable = false)
    private String nom;

    @Column(nullable = false)
    private String adresse;

    @Column
    private String telephone;

    @Column(name = "a_emporter")
    private Boolean aEmporter;

    @Column(name = "sur_place")
    private Boolean surPlace;

    @Column
    private Integer prix;

    @Column(name = "accespmr")
    private Boolean accesPMR;

    @Column(nullable = false)
    private String latitude;

    @Column(nullable = false)
    private String longitude;

    @Column
    private String website;

    @ManyToMany
    @JoinTable(
        name = "type_restau",
        joinColumns = @JoinColumn(name = "id_restau", referencedColumnName = "id_restau"),
        inverseJoinColumns = @JoinColumn(name = "id_type", referencedColumnName = "id_type")
    )
    @Builder.Default
    private Collection<TypeRestau> typerestaus = new ArrayList<>();

    @OneToMany(mappedBy = "preferencePK.restau", cascade = CascadeType.REMOVE)
    @JsonIgnore
    @Builder.Default
    private Collection<Preference> preference = new ArrayList<>();
}
