package fr.vincent.ramiere.mangerautourdesimplonback.models;

import com.fasterxml.jackson.annotation.JsonBackReference;
import jakarta.persistence.*;
import lombok.*;

import java.util.ArrayList;
import java.io.Serializable;
import java.util.List;

@Entity
@Table(name = "type")
@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class TypeRestau implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id_type")
    private int id;

    @Column(nullable = false)
    private String libelle;

    @ManyToMany(mappedBy = "typerestaus")
    @JsonBackReference("restaurants")
    @Builder.Default
    private List<Restaurant> restaurants = new ArrayList<>();
}
